<?php
if (!defined('ABSPATH')) {
	exit();
}

if (!class_exists('App_Expert_Tax_Post_Types_Meta_Data')) {
	class App_Expert_Tax_Post_Types_Meta_Data implements App_Expert_IResponnse_Meta_data
	{

		public function support_listing()
		{
			return true;
		}

		/**
		 * @param array $data
		 *
		 * @return void
		 */
		public  function attach_data(array &$data)
		{
			if (!isset($data['id']) || empty($data['id'])) {
				return;
			}

			if (!isset($data['taxonomy']) || empty($data['taxonomy'])) {
				return;
			}
			global $wp_taxonomies;
			$post_types = (isset( $wp_taxonomies[$data['taxonomy']] ) ) ? $wp_taxonomies[$data['taxonomy']]->object_type : [];
			$post_types = array_combine($post_types, $post_types);
			$post_types_data = get_post_types([], 'object');
			$post_types_data = array_intersect_key($post_types_data, $post_types);
			$required_post_type_data = [];

			foreach($post_types_data as $post_type){
				$needed_data = [
					'name' => $post_type->label,
					'slug' => $post_type->name,
					'rest_base' => $post_type->rest_base ? $post_type->rest_base : $post_type->name
				];
				$required_post_type_data[] = $needed_data;
			}
			
			
			$data['taxonomy_post_types'] = $required_post_type_data;
		}
	}
}
