<?php
if (!defined('ABSPATH')){
	exit();
}

if (!class_exists('App_Expert_Language_Handler')){

	class App_Expert_Language_Handler
    {
        public static function get_active_languages() {
            if (in_array('sitepress-multilingual-cms/sitepress.php', apply_filters('active_plugins', get_option('active_plugins')))) {
                $langs = apply_filters('wpml_active_languages', NULL, 'orderby=id&order=asc');
                return $langs;
            }
            else
            {
                $langs = array();
                $locale = get_locale();
                require_once( ABSPATH . 'wp-admin/includes/translation-install.php' );
                $translations = wp_get_available_translations();
                if($locale === 'en_US'){
                    $langs['en'] = array(
                        'code'=> 'en',
                        'id'=> '',
                        'native_name'=> 'English',
                        'major'=> '',
                        'active'=> '',
                        'default_locale'=> 'en_US',
                        'encode_url'=> '',
                        'tag'=> '',
                        'translated_name'=> 'English',
                        'url'=> '',
                        'country_flag_url'=> '',
                        'language_code'=> ''
                    );
                }
                elseif(isset($translations[$locale])){
                    $translation = $translations[$locale];
                    $langs[current( $translation['iso'] )] = array(
                        'code'=> current( $translation['iso'] ),
                        'id'=> '',
                        'native_name'=> $translation['native_name'],
                        'major'=> '',
                        'active'=> '',
                        'default_locale'=> $translation['language'],
                        'encode_url'=> '',
                        'tag'=> '',
                        'translated_name'=> $translation['english_name'],
                        'url'=> '',
                        'country_flag_url'=> '',
                        'language_code'=> ''
                    );
                }
                else{
                    $langs['en'] = array(
                        'code'=> 'en',
                        'id'=> '',
                        'native_name'=> 'English',
                        'major'=> '',
                        'active'=> '',
                        'default_locale'=> 'en_US',
                        'encode_url'=> '',
                        'tag'=> '',
                        'translated_name'=> 'English',
                        'url'=> '',
                        'country_flag_url'=> '',
                        'language_code'=> ''
                    );
                }
                return $langs;
            }
        }
        public static function switch_lang($lang){
            if (in_array('sitepress-multilingual-cms/sitepress.php', apply_filters('active_plugins', get_option('active_plugins')))) {
                global $sitepress;
                $sitepress->switch_lang($lang,true);
            }
        }
        public static function get_user_locale($user_id){
            $local=get_user_meta($user_id,'_as_current_lang',true);
            if(!$local){
                $local = get_user_locale($user_id);
                $local = explode("_",$local);
                $local = $local[0];
            }
            return $local;
        }

    }
}