<?php
if (!defined('ABSPATH')){
	exit();
}

if (!class_exists('App_Expert_Notification_Handler')){

	class App_Expert_Notification_Handler
    {
        public  $_runner;
        public function __construct()
        {
            require_once APP_EXPERT_PATH . 'includes/handler/app-expert-db-handler.php';
            require_once APP_EXPERT_PATH . 'includes/handler/app-expert-fcm-handler.php';
            $this->_runner = App_Expert_DB_Handler_Handler::get_instance();
        }

        public function save(array $title,array  $content, $target=null, $segment="", $attachment_id=null,$type="manual",$object_id=null,$user_id=null){
            global $wpdb;
            $data=[
                "title" => json_encode($title),
                "content" => json_encode($content),
                "target" => $target,
                "segment" => json_encode($segment),
                "attachment_id" => $attachment_id,
                "type" => $type,
                "object_id" => $object_id,
                "created_at" => gmdate( 'Y-m-d H:i:s' )
            ];
            $wpdb->insert($this->_runner->AE_Notification_Table_name,$data);

            $notification_id = $wpdb->insert_id;
            if(!$notification_id) return [];
            $data['id']= $notification_id;
            if($user_id){
                $wpdb->insert($this->_runner->AE_User_Notification_Table_name,[
                    "user_id" => $user_id,
                    "notification_id" => $notification_id,
                    "is_read" => "0"
                ]);
            }
            $firstKey = array_key_first($title);
            $id=wp_insert_post([
                'post_title'=>"$type Push => title:{$title[$firstKey]}...",
                'post_type'=>'as_notifications',
                'post_status'=>'publish',
                ]);
            add_post_meta($id,'_as_push_notification_id',$notification_id);
            return $data;
        }

        public function send_welcome_msg($user_id){
            $notification_options = get_option('notification_options');
            $is_option_exist = array_key_exists('user_signup',$notification_options['general_settings']);
            if($is_option_exist){
                $title=[];
                $content=[];
                $this->_lang  = App_Expert_Language_Handler::get_active_languages();
                $is_sent=get_user_meta($user_id,"_ae_register_push",true);
                if(!$is_sent) {
                    foreach ($this->_lang as $lang=>$obj){
                        App_Expert_Language_Handler::switch_lang($lang);
                        $title[$lang]   = __('Welcome', 'app-expert');
                        $content[$lang] = __('Thank you for signing up', 'app-expert');
                    }
                    $_user_token   = get_user_meta($user_id,'_as_notification_tokens',true);
                    if(!$_user_token) {
                        update_user_meta($user_id,"_ae_register_push",0);
                    }else{
                        update_user_meta($user_id,"_ae_register_push",1);
                        $_notification = $this->save($title,$content,null,[],null,"user",$user_id,$user_id);
                        if($_notification){
                            $_lang             = get_user_meta($user_id,'_ae_user_lang',true);
                            if(!$_lang) $_lang = App_Expert_Language_Handler::get_user_locale($user_id);
                            $_notification['title'] =  $title[$_lang];
                            $_notification['content'] =  $content[$_lang];
                            $_notification['segment']=null;
                            $_notification['attachment']=null;
                            if(!is_array($_user_token))$_user_token=[$_user_token];
                            foreach ($_user_token as $token){
                                App_Expert_FCM_Handler::sendMessage($_notification['title'],$_notification['content'],$token,$_notification,'token');
                            }
                        }
                    }
                }
            }
        }

        public function get_condition(WP_User $user){
            $date=$user->user_registered;
            $user_id = $user->ID;
            $currentUserRoles = get_user_by("ID",$user_id)->roles;
            $currentUserRoles = '"%'.implode('%" or like "%',$currentUserRoles).'%"';

            return "from {$this->_runner->AE_Notification_Table_name} as notification
                left join {$this->_runner->AE_User_Notification_Table_name} as notification_user on (notification.id=notification_user.notification_id and notification_user.user_id='{$user_id}')
                where 
                     notification.created_at >= '{$date}'
                 and (
                     (notification.type ='manual' and notification.segment like {$currentUserRoles})
                  or (notification.type ='manual' and notification.segment = '[]')
                  or (notification.type ='manual' and notification.segment like '%loggedin%')
                  or (notification.type ='user'   and notification_user.id is not null )
                  or (notification.type ='order'  and notification_user.id is not null )
                  or (notification.type ='review' and notification_user.id is not null )
                  or (notification.type ='post'  )
               )";
        }

        public function get_unseen_count($user){
            global $wpdb;
            $qCond=$this->get_condition($user);
            return (int)$wpdb->get_var("select count(notification.id)
                    $qCond
                    and (notification_user.is_read !=1 or notification_user.is_read is null )");

        }
    }
}