<?php
if (!defined('ABSPATH')){
	exit();
}

if (!class_exists('App_Expert_WC_Product_Handler')){

	class App_Expert_WC_Product_Handler  {
        public static function get_price($product,$cost){
            if ( 'incl' === get_option( 'woocommerce_tax_display_shop' ) ) {
                if ( function_exists( 'wc_get_price_excluding_tax' ) ) {
                    $display_price = wc_get_price_including_tax($product , array( 'price' => $cost ) );
                } else {
                    $display_price = $product->get_price_including_tax( 1, $cost );
                }
            } else {
                if ( function_exists( 'wc_get_price_excluding_tax' ) ) {
                    $display_price = wc_get_price_excluding_tax( $product, array( 'price' => $cost ) );
                } else {
                    $display_price = $product->get_price_excluding_tax( 1, $cost );
                }
            }
            return $display_price;
        }
        public static function get_prices($product){
            return [
                'ae_regular_price' => (float) self::get_price($product,$product->get_regular_price()),
                'ae_sale_price'    => (float) self::get_price($product,$product->get_sale_price()),
            ];
        }
        public static function get_data($product,$wc_product=null){
            require_once APP_EXPERT_PATH . 'includes/authentication/app-expert-authentication.php';
            $user_id =self::get_user();

            if(!$wc_product)$wc_product=wc_get_product($product['id']);
            //================ fix attribute label wpml translation issue ================
            $newAttr = [];
            if(isset($product["attributes"])){
                foreach ($product["attributes"] as $attr) {
                    switch (gettype($attr)){
                        case "array":
                            $attr['label'] = wc_attribute_label($attr['name'], '');
                            break;
                        case "object":
                            $attr->label = wc_attribute_label($attr->name, '');
                            break;
                    }
                    $newAttr[] = $attr;
                }
                $product["attributes"] = $newAttr;
            }
            //================ fix attribute label wpml translation issue ================

            //================  review changes ================
            $product['has_bought_product']= $user_id && wc_customer_bought_product("", $user_id, $product['id']);
            $product['review_count']=$wc_product->get_review_count();
            //================  review changes ================

            //================  wishlist changes ================
            $is_wishlisted = false;
            if ($user_id&&in_array(
                    'yith-woocommerce-wishlist/init.php',
                    apply_filters( 'active_plugins', get_option( 'active_plugins' ) )
                )) {
                $wishlist_product = \WC_Data_Store::load('wishlist-item')->query([
                    'user_id' => $user_id,
                    'product_id' => $product['id'],
                    'wishlist_id' => 'all',
                ] );
                if(!empty($wishlist_product)){
                    $is_wishlisted = true;
                }
            }
            $product['is_wishlisted'] = $is_wishlisted;
            //================  wishlist changes ================

            //================ fix product type issue ================
            $types= get_the_terms( $product['id'], 'product_type');
            $product['type'] = !empty($types)?$types[0]->name:$product['type'];
            //================  fix product type issue  ================

            //================  prices fix ================
            $prices=self::get_prices($wc_product);
            return apply_filters('ae_rest_product_obj',array_merge($product,$prices),$wc_product);
            //================  prices fix ================
        }
        public static function get_user(){
            $user_id = get_current_user_id();
            $headers = getallheaders();
            if (isset($headers['AUTHORIZATION'])) {
                $authorization_header = $headers['AUTHORIZATION'];
                $token_auth_result = App_Expert_Authentication::authenticate_user_token($authorization_header);
                if (!is_wp_error($token_auth_result)) {
                    //append user id to request so that u dont need to decode the token again to get id
                    $user_id = $token_auth_result;
                }
            }
            return $user_id;
        }

    }
}