<?php
if (!defined('ABSPATH')) {
	exit();
}

if (!class_exists('App_Expert_Woocommerce_Authentication')) {

	class App_Expert_Woocommerce_Authentication
	{


		public function __construct()
		{
			add_filter('init', array($this, 'autenticate_woocommerce_checkout'), 10);
		}




		public function autenticate_woocommerce_checkout()
		{
			$checkout_page = @get_page_by_path(App_Expert_Woocommerce_Checkout::MOBILE_CHECKOUT_PAGE_SLUG);
			if (!$checkout_page || is_admin()) {
				return;
			}


			$request_uri = $_SERVER['REQUEST_URI'];
			$relative_page_permalink = str_replace(home_url(), '', get_permalink($checkout_page->ID));
			if (false === strpos($request_uri, $relative_page_permalink)) {
				return;
			}
			$authorization_header = '';
			if (isset($_GET['user_token']) && !empty($_GET['user_token'])) {
				$authorization_header = "Bearer " . $_GET['user_token'];
			}


			// Guest user case
			if (isset($_GET['guest_user']) && !empty($_GET['guest_user'])) {  // Guest case
				if (!empty(get_current_user_id())) {
					$this->clear_current_user();
					wp_redirect($request_uri);
					exit;
				}
				return;
			}

			// Authenticated user case
			$token_auth_result = App_Expert_Authentication::authenticate_user_token($authorization_header);
			if (!is_wp_error($token_auth_result)) {
				$user_id = $token_auth_result;
				if ($user_id != get_current_user_id()) {
					$this->open_user_session($user_id);
					wp_redirect($_SERVER['REQUEST_URI']);
					exit;
				}
			} else {
				wp_die("You are not authorized to access this page");
			}

			return $user_id;
		}



		protected function is_checkout_custom_page()
		{
			return is_page(App_Expert_Woocommerce_Checkout::MOBILE_CHECKOUT_PAGE_SLUG);
		}


		protected function clear_current_user()
		{
			wp_clear_auth_cookie();
			wp_destroy_current_session();
		}

		protected function open_user_session($user_id)
		{
			$user = get_user_by('ID', $user_id);

			clean_user_cache($user->ID);
			$this->clear_current_user();

			wp_set_current_user($user->ID);
			wp_set_auth_cookie($user->ID, true, false);
			update_user_caches($user);
		}

	}
}
new App_Expert_Woocommerce_Authentication();
