<?php
if (!defined('ABSPATH')) {
    exit();
}

class App_Expert_Store_API_Products_Controller
{
    private  $routesAllRegex="/\/wc\/store\/v1\/products(\/)?$/";
    private  $routesRegex="/\/wc\/store\/v1\/products\/[0-9]+$/";
    public function __construct(){
        require_once APP_EXPERT_PATH . 'includes/handler/app-expert-wc-product-handler.php';
        add_filter('rest_request_after_callbacks', array($this, 'modify_product_data'), 999, 3);
    }


    public function modify_product_data($response, array $handler, \WP_REST_Request $request) {
        if( $response instanceof WP_Error) return $response;
        $current_route = $request->get_route();
        $matches=[];
        //list of products
        preg_match($this->routesAllRegex,$current_route,$matches);
        if(count($matches)){
            return $this->edit_list($response);
        }
        preg_match($this->routesRegex,$current_route,$matches);
        if(count($matches)){
            return $this->edit_one($response);
        }
        return $response;
    }
    public function add_extra_data($product){
        return App_Expert_WC_Product_Handler::get_data($product);
    }

    private function edit_list(WP_REST_Response $response)
    {
        $new_data=[];
        foreach ($response->get_data() as $product){
            $new_data[]=$this->add_extra_data($product);
        }
        $response->set_data($new_data);
        return $response;
    }

    private function edit_one(WP_REST_Response $response)
    {
        $response->set_data($this->add_extra_data($response->get_data()));
        return $response;
    }


}

 new App_Expert_Store_API_Products_Controller();

